import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import java.awt.geom.* ;
import javax.swing.* ;
import javax.swing.border.*;
import java.util.* ; 
import java.io.*;

public class Alternativo extends JFrame 
{
Color back  = new Color(210,210,210);
Color dgray = new Color(60,60,60);
Color black = new Color(0,0,0);
Color white = new Color(255,255,255);
drawpaper parent;
Alternativo()
{
    JPanel newtool = new JPanel();
    newtool.setLayout(new GridLayout(19,1));
    newtool.setSize(60,460);

    setBackground(black);

    Icon twopoint = new ImageIcon("images/twopoint.gif");
    Icon atriz = new ImageIcon("images/atriz.gif");
    Icon center = new ImageIcon("images/center.gif");
    Icon middpoint = new ImageIcon("images/middpoint.gif");
    Icon onelinint = new ImageIcon("images/onelinint.gif");
    Icon twocir = new ImageIcon("images/twocir.gif");
    Icon perpen = new ImageIcon("images/perpen.gif");
    Icon paralela = new ImageIcon("images/paralela.gif");
    Icon cort1 = new ImageIcon("images/cort1.gif");
    Icon cort2 = new ImageIcon("images/cort2.gif");
    Icon tgright = new ImageIcon("images/tgright.gif");
    Icon tgleft = new ImageIcon("images/tgleft.gif");
    Icon tgs = new ImageIcon("images/tgs.gif");
    Icon medi = new ImageIcon("images/medi.gif");
    Icon inter = new ImageIcon("images/inter.gif");
    Icon intel = new ImageIcon("images/intel.gif");
    Icon intel2 = new ImageIcon("images/intel2.gif");
    Icon bis = new ImageIcon("images/bis.gif");
    Icon tgoval1 = new ImageIcon("images/tgoval1.gif");
    Icon tgoval2 = new ImageIcon("images/tgoval2.gif");
    Icon inlin = new ImageIcon("images/inlin.gif");

    JButton perp = new JButton() ;
    perp = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    perp.setIcon(perpen);
    perp.setSize(60,30);
    perp.setToolTipText("Draws the perpendicular from selected point to selected line");
    perp.setBackground(back);
    perp.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu"){
				    g= new nubj_linea((nubj_punto)j,(nubj_linea)i,2,drawpaper.glist);
				    repaint();
				}
			}

			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    g= new nubj_linea((nubj_punto)i,(nubj_linea)j,2,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton medio = new JButton() ;
    medio = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    medio.setIcon(medi);
    medio.setSize(60,30);
    medio.setToolTipText("Draws the line from selected point to middle point of selected line");
    medio.setBackground(back);
    medio.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu"){
				    g= new nubj_linea((nubj_punto)j,(nubj_linea)i,4,drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    g= new nubj_linea((nubj_punto)i,(nubj_linea)j,4,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton inters = new JButton() ;
    inters = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    inters.setIcon(inter);
    inters.setSize(60,30);
    inters.setToolTipText("Draws the intersected point between two selected lines");
    inters.setBackground(back);
    inters.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    g= new nubj_punto((nubj_linea)j,(nubj_linea)i, 3, drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton mediatriz = new JButton() ;
    mediatriz = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    mediatriz.setIcon(atriz);
    mediatriz.setSize(60,30);
    mediatriz.setToolTipText("Draws the perpendicular to a selected line in the middle");
    mediatriz.setBackground(back);
    mediatriz.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		nubj i,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
				    g= new nubj_linea((nubj_linea)i, 5, drawpaper.glist);
				    repaint();
			}
		    }     
		}
	    }
	});


JButton bisec = new JButton() ;
bisec = new DoubleBorderedButton(
new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
bisec.setIcon(bis);
bisec.setSize(60,30);
bisec.setToolTipText("Draws the line that bisecs two selected lines from the side of two selected points.");
bisec.setBackground(back);
bisec.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent evt){
	nubj i,j,k,l,g;
	for(i=drawpaper.glist.ghead;i!=null;i=i.next){
	    if(i.select==1 && i.nombre=="li")
	    {
		    for(j=i.next;j!=null;j=j.next)
			if(j.select==1 && j.nombre=="li"){
			    for(k=drawpaper.glist.gtail;k!=null;k=k.prev){
				if(k.select==1 && k.nombre=="pu")
				{
					for(l=k.prev;l!=null;l=l.prev)
					    if(l.select==1 && l.nombre=="pu"){
						g= new nubj_linea((nubj_linea)j,(nubj_linea)i,(nubj_punto)k,(nubj_punto)l,6,drawpaper.glist);
						repaint();
					    }
				    }
				}
			    }
			}
		}
    }
});

    JButton paral = new JButton() ;
    paral = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    paral.setIcon(paralela);
    paral.setSize(60,30);
    paral.setToolTipText("Draws a line parallel to another trough a given central point.");
    paral.setBackground(back);
    paral.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu"){
				    g= new nubj_linea((nubj_punto)j,(nubj_linea)i, 3, drawpaper.glist);
				    repaint();
				}
			}

			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    g= new nubj_linea((nubj_punto)i,(nubj_linea)j, 3, drawpaper.glist);
				    repaint();
				}
			}
		    }
		}
	    }
	});


    JButton tgri = new JButton() ;
    final Color green = new Color(0,255,0);
    tgri = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tgri.setIcon(tgright);
    tgri.setSize(60,30);
    tgri.setToolTipText("Draws the tangent from selected point to spiral-circle in clockwise direction");
    tgri.setBackground(back);
    tgri.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g; nubj_punto p;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new nubj_linea((nubj_punto)j,(nubj_mpcircle)i,7,1,drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc"){
				    g= new nubj_linea((nubj_punto)i,(nubj_mpcircle)j,7,1,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton tglf = new JButton() ;
    tglf = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tglf.setIcon(tgleft);
    tglf.setSize(60,30);
    tglf.setToolTipText("Draws the tangent from selected point to spiral-circle in anti-clockwise direction");
    tglf.setBackground(back);
    tglf.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new nubj_linea((nubj_punto)j,(nubj_mpcircle)i,7,2,drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc"){
				    g= new nubj_linea((nubj_punto)i,(nubj_mpcircle)j,7,2,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton tgov1 = new JButton() ;
    tgov1 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tgov1.setIcon(tgoval1);
    tgov1.setSize(60,30);
    tgov1.setToolTipText("Draws the tangent from selected point to oval in anti-clockwise direction");
    tgov1.setBackground(back);
    tgov1.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new nubj_linea((nubj_punto)j,(nubj_oval)i,8,1,drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){
				    g= new nubj_linea((nubj_punto)i,(nubj_oval)j,8,1,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton tgov2 = new JButton() ;
    tgov2 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tgov2.setIcon(tgoval2);
    tgov2.setSize(60,30);
    tgov2.setToolTipText("Draws the tangent from selected point to oval in anti-clockwise direction");
    tgov2.setBackground(back);
    tgov2.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new nubj_linea((nubj_punto)j,(nubj_oval)i,8,2,drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){
				    g= new nubj_linea((nubj_punto)i,(nubj_oval)j,8,2,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton twopo = new JButton() ;
    twopo = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    twopo.setIcon(twopoint);
    twopo.setSize(60,30);
    twopo.setToolTipText("Draws the segment between two selected points.");
    twopo.setBackground(back);
    twopo.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new nubj_linea((nubj_punto)j,(nubj_punto)i,1,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton onelin = new JButton() ;
    onelin = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    onelin.setIcon(onelinint);
    onelin.setSize(60,30);
    onelin.setToolTipText("Draws the two limit points of a selected line.");
    onelin.setBackground(back);
    onelin.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    j= new nubj_punto((nubj_linea)i, 2, 1, drawpaper.glist);
			    g= new nubj_punto((nubj_linea)i, 2, 2, drawpaper.glist);
			    repaint();
			}
		    }     
		}
	    }
	});

    JButton middle = new JButton() ;
    middle = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    middle.setIcon(middpoint);
    middle.setSize(60,30);
    middle.setToolTipText("Draws the middle point of a selected line.");
    middle.setBackground(back);
    middle.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    j= new nubj_punto((nubj_linea)i, 1, 1, drawpaper.glist);
			    repaint();
			}
		    }     
		}
	    }
	});

    JButton twcir = new JButton() ;
    twcir = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    twcir.setIcon(twocir);
    twcir.setSize(60,30);
    twcir.setToolTipText("Draws a spiral-circle using two selected points.");
    twcir.setBackground(back);
    twcir.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new nubj_mpcircle((nubj_punto)j,(nubj_punto)i,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton cor1 = new JButton() ;
    cor1 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    cor1.setIcon(cort1);
    cor1.setSize(60,30);
    cor1.setToolTipText("Creates the first point of intersection between selected line & spiral-circle");
    cor1.setBackground(back);
    cor1.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li")
				{
				    g= new nubj_punto((nubj_mpcircle)i, (nubj_linea)j, 5, 1, drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc"){
				    g= new nubj_punto((nubj_mpcircle)j, (nubj_linea)i, 5, 1, drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});


    JButton centr = new JButton() ;
    centr = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    centr.setIcon(center);
    centr.setSize(60,30);
    centr.setToolTipText("Creates the point center of a selected spiral-circle");
    centr.setBackground(back);
    centr.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    g= new nubj_punto((nubj_mpcircle)i, 4, drawpaper.glist);
			    repaint();
			}
		    }
		}     
	    }
	});


    JButton cor2 = new JButton() ;
    cor2 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    cor2.setIcon(cort2);
    cor2.setSize(60,30);
    cor2.setToolTipText("Creates the second point of intersection between selected line & spiral-circle");
    cor2.setBackground(back);
    cor2.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li")
				{
				    g= new nubj_punto((nubj_mpcircle)i,(nubj_linea)j, 5, 2, drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc"){
				    g= new nubj_punto((nubj_mpcircle)j,(nubj_linea)i, 5, 2, drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton corov1 = new JButton() ;
    corov1 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    corov1.setIcon(intel);
    corov1.setSize(60,30);
    corov1.setToolTipText("Creates the first point of intersection between selected line & oval");
    corov1.setBackground(back);
    corov1.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li")
				{
				    g= new nubj_punto((nubj_oval)i,(nubj_linea)j,6,1,drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){
				    g= new nubj_punto((nubj_oval)j,(nubj_linea)i,6,1,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton corov2 = new JButton() ;
    corov2 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    corov2.setIcon(intel2);
    corov2.setSize(60,30);
    corov2.setToolTipText("Creates the second point of intersection between selected line & oval");
    corov2.setBackground(back);
    corov2.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		nubj i,j,g;
		for(i=drawpaper.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li")
				{
				    g= new nubj_punto((nubj_oval)i,(nubj_linea)j,6,2,drawpaper.glist);
				    repaint();
				}
			}
			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){
				    g= new nubj_punto((nubj_oval)j,(nubj_linea)i,6,2,drawpaper.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});


    getContentPane().add(newtool);

    newtool.add(twopo);
    newtool.add(middle);
    newtool.add(onelin);
    newtool.add(mediatriz);
    newtool.add(perp);
    newtool.add(paral);
    newtool.add(medio);
    newtool.add(inters);
    newtool.add(bisec);
    newtool.add(twcir);
    newtool.add(centr);
    newtool.add(cor1);
    newtool.add(cor2);
    newtool.add(tgri);
    newtool.add(tglf);
    newtool.add(corov1);
    newtool.add(corov2);
    newtool.add(tgov1);
    newtool.add(tgov2);

    pack();
    setVisible(false);
}    
}

