import java.awt.*;
import java.awt.event.*;

public class ImageFrame
    extends Frame {
  public ImageFrame() { this("Image-Control"); }
  
  public ImageFrame(String title) {
    super(title);
    createUI();
  }
  
  protected void createUI() {
    int w= imatot.ww+10;
    int h= imatot.hh+27;
    setSize(w,h);
    center();

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
	//        System.exit(0);
      }
    });
  }
  
  public void center() {
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = getSize();
    int x = (screenSize.width - frameSize.width) / 2;
    int y = (screenSize.height - frameSize.height) / 2;
    setLocation(x, y);
  }
}
