import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//***********************************************************************

class nubj_mpcircle extends nubj

//***********************************************************************

{
    Color c;
    public int x0,x1,y0,y1,z0,z1,R,w1,h1;
    public double R1;
    double angulo, escal;
    nubj_punto mi1;
    nubj_punto mi2;
    int ikk=0;

    nubj_mpcircle(nubj_punto p1,nubj_punto p2,nubj_list p)
  {
    super(p);
	n = 2;
	nombre = "mpc";
	select = 3;
	mi1 = p1;
	mi2 = p2;
  }

    nubj_mpcircle(int xx0,int yy0,Color cc,nubj_list p)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	xd[0]=x0; xd[1]=x1; yd[0]=y0; yd[1]=y1;
	n = 2;
	nombre = "mpc";
	select = 3;
    }

    public void transform(double xc, double yc, double zc)
    {
	double ij, ji;
	ikk=1;
	n=2;
	if(value==0 || value==1 || value==2 || value==3 || value==5 || value==6 || value==9 || value==11 || value==12 || value==14)
	    {
		aviso.mostrar(true);
	    }
	else if(value!=0 && value!=15) modi(xc,yc,zc,n);
	T =(float)0.0;
    	escal=Math.abs(es/10);
	x0=(int)xd[0];
	x1=(int)xd[1];
	y0=(int)yd[0];
	y1=(int)yd[1];
	z0=(int)zd[0];
	z1=(int)zd[1];
	if(value==7)xscal=(float)(escal/10);
	if(value==8)yscal=(float)(escal/10);
	if(value==10){xscal=(float)(escal/10);yscal=xscal;}
	if(value==4)T=(float)(escal/100);
    }

    public void paint(Graphics g) 
    {
	n=2;int x,y;
	c = cc;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;

	if(mi1!=null)
	  {
	    xd[0] = mi1.xd[0]; yd[0] = mi1.yd[0]; 
	    xd[1] = mi2.xd[0]; yd[1] = mi2.yd[0];
	    x0=(int)(xd[0]+.5);x1=(int)(xd[1]+.5);
	    y0=(int)(yd[0]+.5);y1=(int)(yd[1]+.5);
	  }

	xc=xd[0];yc=yd[0];zc=zd[0];
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	if(ikk==0 || value==10)
	    {
		R1=Math.sqrt((xd[1]-xd[0])*(xd[1]-xd[0])+(yd[1]-yd[0])*(yd[1]-yd[0]));
		R=(int)(R1+0.49);
	    }
	setminmax();
	if(select!=0)
	    {
		g.setColor(Color.red);
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		g2.drawLine(x0,y0,x1,y1);
		g.fillRect(x0-1,y0-1,3,3);
		g.fillRect(x1-1,y1-1,3,3);
		g.setColor(cl);
		g.drawOval((x0-R),(y0-R), 2*R, 2*R);
		setminmax();
	    }
	if(select==0)
	    {
		g.setColor(cl);
	    stroke = new BasicStroke(thickness);
	    g2.setStroke(stroke);
		if(refill==0)
		    {
			g.drawOval((x0-R),(y0-R), 2*R, 2*R);
		    }
		if(refill==1)
		    {
			g.setColor(cc);
			g.fillOval((x0-R),(y0-R), 2*R, 2*R);
			g.setColor(cl);
			g.drawOval((x0-R),(y0-R), 2*R, 2*R);
		    }
		if(espi>1)
		    {
			for(int kk=1;kk<=espi;kk++)
			    {
				int rr=(int)(R/espi);
				g.drawOval((x0-(kk*rr)),(y0-(kk*rr)), 2*(kk*rr), 2*(kk*rr));
			    }
		    }
		
	    }
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);
	      g.setColor(cl);
    }
    public void metapost(BufferedWriter out) 
    {
	c=cc;
	try 
	    {
		float rc = (float) cl.getRed()/255f;
		float vc = (float) cl.getGreen()/255f;
		float ac = (float) cl.getBlue()/255f;
		float ny0 = (float)(1180 - (yd[0]/uesc));
		angulo = Math.atan2((yd[1]-yd[0]),(xd[1]-xd[0])) ;
		out.write("pickup pencircle scaled "+thickness+";\npath a;\n");
		if(espi<2)
		    {
			out.write("a:= fullcircle scaled "+(2*R1/uesc)+"u;\n");
			
			if(refill == 1)
			    {
				float cr = (float) c.getRed()/255f;
				float cv = (float) c.getGreen()/255f;
				float ca = (float) c.getBlue()/255f;
				out.write ("col:=("+cr+","+cv+","+ca+");\n");
				out.write ("loc:=("+rc+","+vc+","+ac+");\n");
			    }
		    }
		float valx=(float)(xd[0]/uesc),valy=ny0,w=(float)(R1/(4*espi*uesc));
		if(espi>1)
		    {
			out.write ("loc:=("+rc+","+vc+","+ac+");\n");
			out.write("a:=(0u,0u);\n");
			out.write("for i=1 step 4 until "+(int)(espi*4)+":\n");
			if(sentido==0)out.write("a:=a..(0u,(0-i*"+w+")*u)..((0-(i+1)*"+w+")*u,0u)..(0u,(0+(i+2)*"+w+")*u)..((0+(i+3)*"+w+")*u,0u);\n");
			else out.write("a:=a..(0u,(0-i*"+w+")*u)..((0+(i+1)*"+w+")*u,0u)..(0u,(0+(i+2)*"+w+")*u)..((0-(i+3)*"+w+")*u,0u);\n");
			out.write("endfor;\n");
		    }
		if(text_on_path==false)
		    {
			out.write ("loc:=("+rc+","+vc+","+ac+");\n");
			if(refill == 1){out.write("filldraw a  shifted("+valx+"u, "+valy+"u) withcolor col;\n");}
			out.write("draw a xscaled "+xscal+" yscaled "+yscal+" slanted "+T+" rotated "+(float)(angulo*(-180)/(float)pi)+" shifted("+valx+"u, "+valy+"u) withcolor loc ");
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }
		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
	    }
    catch (IOException ex) { }
}

    public void moveobj(int x,int y)
    {
	x1 += x;xd[1] += (double)x;
	x0 += x;xd[0] += (double)x;
	y1 += y;yd[1] += (double)y;
	y0 += y;yd[0] += (double)y;

	if(x0<x1) { xmin = x0 ; xmax = x1 ; }
	else      { xmin = x1 ; xmax = x0 ; }
	if(y0<y1) { ymin = y0 ; ymax = y1 ; }
	else      { ymin = y1 ; ymax = y0 ; }
    }

    public void movepoint(int x,int y)
    {
	if(select==2)
	    {
		x0 += x; xd[0] += (double)x;
		y0 += y; yd[0] += (double)y;
	    }
	if(select==3)
	    {
		x1 += x; xd[1] += (double)x;
		y1 += y; yd[1] += (double)y;
	    }
	if(x0<x1) { xmin = x0 ; xmax = x1 ; }
	else      { xmin = x1 ; xmax = x0 ; }
	if(y0<y1) { ymin = y0 ; ymax = y1 ; }
	else      { ymin = y1 ; ymax = y0 ; }
    }

    public boolean selectpoint(int x,int y)
    {
	if(x-x0<3 && x-x0>-3 && y-y0<3 && y-y0>-3)
	    {
		select = 2;
		return(true);
	    }
	else if(x-x1<3 && x-x1>-3 && y-y1<3 && y-y1>-3)
	    {
		select = 3;
		return(true);
	    }
	return(false);
    }

    public boolean selectobj(int x,int y)
    {
	if(x>=xmin && x<=xmax && y>=ymin && y<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<x0 && xx1>x1 && yy0<y0 && yy1>y1)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void setminmax()
    {
	xmin = 1000;
	ymin = 1000;
	xmax = -1000;
	ymax = -1000;
	if((x0-R)<xmin) xmin = x0-(R+2);
	if((y0-R)<ymin) ymin = y0-(R+2);
	if((x0+R)>xmax) xmax = x0+(R+2);
	if((y0+R)>ymax) ymax = y0+(R+2);

    }
}

